<center><a href="ex2.c">Actual source code: ex2.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:19:03+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>static char help[] = <font color="#666666">"Tests <A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A> functions.\n\n"</font>;

<a name="line3">  3: </a><font color="#A020F0">#include &lt;stdlib.h&gt;</font>
<a name="line4">  4: </a><font color="#A020F0">#include &lt;stdio.h&gt;</font>
<a name="line5">  5: </a><font color="#A020F0">#include &lt;string.h&gt;</font>
<a name="line6">  6: </a><font color="#A020F0">#include &lt;time.h&gt;</font>
<a name="line7">  7: </a><font color="#A020F0">#include &lt;sys/types.h&gt;</font>

<a name="line9">  9: </a><font color="#A020F0">#include </font><font color="#666666">"petsc.h"</font><font color="#A020F0"></font>
<a name="line10"> 10: </a><font color="#A020F0">#include </font><font color="#666666">"petscsys.h"</font><font color="#A020F0"></font>

<a name="line12"> 12: </a><strong><font color="#228B22">#define MAXBSIZE     40</font></strong>
<a name="line13"> 13: </a><strong><font color="#228B22">#define PI           3.1415926535897</font></strong>
<a name="line14"> 14: </a><strong><font color="#228B22">#define DATAFILENAME </font><font color="#666666">"ex2_stock.txt"</font><font color="#228B22"></font></strong>

<a name="line16"> 16: </a><font color="#4169E1"><a name="himaInfoTag"></a>struct himaInfoTag </font>{
<a name="line17"> 17: </a>  int           n;
<a name="line18"> 18: </a>  double        r;
<a name="line19"> 19: </a>  double        dt;
<a name="line20"> 20: </a>  int           totalNumSim;
<a name="line21"> 21: </a>  double        *St0;
<a name="line22"> 22: </a>  double        *vol;
<a name="line23"> 23: </a>};
<a name="line24"> 24: </a><font color="#4169E1">typedef struct himaInfoTag himaInfo;</font>

<a name="line26"> 26: </a><font color="#B22222">/* function protype */</font>
<a name="line27"> 27: </a><strong><font color="#4169E1"><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> readData(<A href="../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,himaInfo *hinfo)</font></strong>;
<a name="line28"> 28: </a><strong><font color="#4169E1">double mcVal(double St, double r, double vol, double dt, double eps)</font></strong>;
<a name="line29"> 29: </a><strong><font color="#4169E1">void exchange(double *a, double *b)</font></strong>;
<a name="line30"> 30: </a><strong><font color="#4169E1">double basketPayoff(double vol[], double St0[], int n, double r,double dt, double eps[])</font></strong>;
<a name="line31"> 31: </a><strong><font color="#4169E1">void stdNormalArray(double *eps, unsigned long <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>,<A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A> ran)</font></strong>;
<a name="line32"> 32: </a><strong><font color="#4169E1">unsigned long divWork(int id, unsigned long num, int np)</font></strong>;

<a name="line34"> 34: </a><font color="#B22222">/* </font>
<a name="line35"> 35: </a><font color="#B22222">   Contributed by Xiaoyan Zeng &lt;zengxia@iit.edu&gt; and Liu, Kwong Ip" &lt;kiliu@math.hkbu.edu.hk&gt;</font>

<a name="line37"> 37: </a><font color="#B22222">   Example of usage: </font>
<a name="line38"> 38: </a><font color="#B22222">     <A href="http://www.mcs.anl.gov/mpi/www/www1/mpirun.html#mpirun">mpirun</A> -np 4 ./ex2 -num_of_stocks 30 -interest_rate 0.4 -time_interval 0.01 -num_of_simulations 10000</font>
<a name="line39"> 39: </a><font color="#B22222">*/</font>

<a name="line43"> 43: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc, char *argv[])</font></strong>
<a name="line44"> 44: </a>{
<a name="line45"> 45: </a>    double         r,dt;
<a name="line46"> 46: </a>    int            n;
<a name="line47"> 47: </a>    unsigned long  i,myNumSim,totalNumSim,numdim;
<a name="line48"> 48: </a>    double         payoff;
<a name="line49"> 49: </a>    double         *vol, *St0, x, totalx;
<a name="line50"> 50: </a>    int            np,myid;
<a name="line51"> 51: </a>    time_t         start,stop;
<a name="line52"> 52: </a>    double         *eps;
<a name="line53"> 53: </a>    himaInfo       hinfo;
<a name="line54"> 54: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A>    ran;

<a name="line57"> 57: </a>    <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char *)0,help);
<a name="line58"> 58: </a>    time(&amp;start);
<a name="line59"> 59: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomCreate.html#PetscRandomCreate">PetscRandomCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;ran);
<a name="line60"> 60: </a><font color="#A020F0">#if defined(PETSC_HAVE_SPRNG)</font>
<a name="line61"> 61: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomSetType.html#PetscRandomSetType">PetscRandomSetType</A>(ran,SPRNG);
<a name="line62"> 62: </a><font color="#A020F0">#elif defined(PETSC_HAVE_RAND)</font>
<a name="line63"> 63: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomSetType.html#PetscRandomSetType">PetscRandomSetType</A>(ran,PETSCRAND);
<a name="line64"> 64: </a><font color="#A020F0">#endif</font>
<a name="line65"> 65: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomSetFromOptions.html#PetscRandomSetFromOptions">PetscRandomSetFromOptions</A>(ran);


<a name="line68"> 68: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>, &amp;np);     <font color="#B22222">/* number of nodes */</font>
<a name="line69"> 69: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>, &amp;myid);   <font color="#B22222">/* my ranking */</font>
<a name="line70"> 70: </a>
<a name="line71"> 71: </a>    hinfo.n           = 31;
<a name="line72"> 72: </a>    hinfo.r           = 0.04;
<a name="line73"> 73: </a>    hinfo.dt          = 1.0/12; <font color="#B22222">/* a month as a period */</font>
<a name="line74"> 74: </a>    hinfo.totalNumSim = 1000;
<a name="line75"> 75: </a>    <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-num_of_stocks"</font>,&amp;(hinfo.n),<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line76"> 76: </a>    <font color="#4169E1">if</font> (hinfo.n &lt;1 || hinfo.n &gt; 31) <A href="../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Only 31 stocks listed in stock.txt. num_of_stocks %D must between 1 and 31"</font>,hinfo.n);
<a name="line77"> 77: </a>    <A href="../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-interest_rate"</font>,&amp;(hinfo.r),<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line78"> 78: </a>    <A href="../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-time_interval"</font>,&amp;(hinfo.dt),<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line79"> 79: </a>    <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-num_of_simulations"</font>,&amp;(hinfo.totalNumSim),<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line81"> 81: </a>    n           = hinfo.n;
<a name="line82"> 82: </a>    r           = hinfo.r;
<a name="line83"> 83: </a>    dt          = hinfo.dt;
<a name="line84"> 84: </a>    totalNumSim = hinfo.totalNumSim;
<a name="line85"> 85: </a>    vol         = hinfo.vol = (double *)malloc(<font color="#4169E1">sizeof</font>(double)*(2*n+1));
<a name="line86"> 86: </a>    St0         = hinfo.St0 = hinfo.vol + n;
<a name="line87"> 87: </a>    readData(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;hinfo);

<a name="line89"> 89: </a>    numdim = n*(n+1)/2;
<a name="line90"> 90: </a>    <font color="#4169E1">if</font> (numdim%2 == 1){
<a name="line91"> 91: </a>      numdim++;
<a name="line92"> 92: </a>    }
<a name="line93"> 93: </a>    eps = (double *)malloc(<font color="#4169E1">sizeof</font>(double)*numdim);

<a name="line95"> 95: </a>    myNumSim = divWork(myid,totalNumSim,np);

<a name="line97"> 97: </a>    x = 0;
<a name="line98"> 98: </a>    <font color="#4169E1">for</font> (i=0;i&lt;myNumSim;i++){
<a name="line99"> 99: </a>        stdNormalArray(eps,numdim,ran);
<a name="line100">100: </a>        x += basketPayoff(vol,St0,n,r,dt,eps);
<a name="line101">101: </a>    }

<a name="line103">103: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Reduce.html#MPI_Reduce">MPI_Reduce</A>(&amp;x, &amp;totalx, 1, MPI_DOUBLE, MPI_SUM,0,<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>);
<a name="line104">104: </a>    time(&amp;stop);
<a name="line105">105: </a>    <font color="#4169E1">if</font> (myid == 0){
<a name="line106">106: </a>        payoff = exp(-r*dt*n)*(totalx/totalNumSim);
<a name="line107">107: </a>        <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Option price = $%.3f "</font>
<a name="line108">108: </a>           <font color="#666666">"using %ds of %s computation with %d %s "</font>
<a name="line109">109: </a>           <font color="#666666">"for %d stocks, %d trading period per year, "</font>
<a name="line110">110: </a>           <font color="#666666">"%.2f%% interest rate\n"</font>,
<a name="line111">111: </a>           payoff,(int)(stop - start),<font color="#666666">"parallel"</font>,np,<font color="#666666">"processors"</font>,n,
<a name="line112">112: </a>           (int)(1/dt),r);
<a name="line113">113: </a>    }
<a name="line114">114: </a>
<a name="line115">115: </a>    free(vol);
<a name="line116">116: </a>    free(eps);
<a name="line117">117: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomDestroy.html#PetscRandomDestroy">PetscRandomDestroy</A>(ran);
<a name="line118">118: </a>    <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line119">119: </a>    <font color="#4169E1">return</font> 0;
<a name="line120">120: </a>}

<a name="line122">122: </a><strong><font color="#4169E1"><a name="stdNormalArray"></a>void stdNormalArray(double *eps, unsigned long <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>, <A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A> ran)</font></strong>
<a name="line123">123: </a>{
<a name="line124">124: </a>  int            i;
<a name="line125">125: </a>  double         u1,u2,t;

<a name="line128">128: </a>  <font color="#4169E1">for</font> (i=0;i&lt;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>;i+=2){
<a name="line129">129: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(ran,&amp;u1);
<a name="line130">130: </a>    <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(ran,&amp;u2);
<a name="line131">131: </a>
<a name="line132">132: </a>    t = sqrt(-2*log(u1));
<a name="line133">133: </a>    eps[i] = t * cos(2*PI*u2);
<a name="line134">134: </a>    eps[i+1] = t * sin(2*PI*u2);
<a name="line135">135: </a>  }
<a name="line136">136: </a>}


<a name="line139">139: </a><strong><font color="#4169E1"><a name="basketPayoff"></a>double basketPayoff(double vol[], double St0[], int n, double r,double dt, double eps[])</font></strong>
<a name="line140">140: </a>{
<a name="line141">141: </a>  double Stk[MAXBSIZE], temp;
<a name="line142">142: </a>  double payoff;
<a name="line143">143: </a>  int    maxk,i,j;
<a name="line144">144: </a>  int    pointcount=0;
<a name="line145">145: </a>
<a name="line146">146: </a>  <font color="#4169E1">for</font> (i=0;i&lt;n;i++) {
<a name="line147">147: </a>    Stk[i] = St0[i];
<a name="line148">148: </a>  }

<a name="line150">150: </a>  <font color="#4169E1">for</font> (i=0;i&lt;n;i++){
<a name="line151">151: </a>    maxk = 0;
<a name="line152">152: </a>    <font color="#4169E1">for</font> (j=0;j&lt;(n-i);j++){
<a name="line153">153: </a>      Stk[j] = mcVal(Stk[j],r,vol[j],dt,eps[pointcount++]);
<a name="line154">154: </a>      <font color="#4169E1">if</font> ((Stk[j]/St0[j]) &gt; (Stk[maxk]/St0[maxk])){
<a name="line155">155: </a>        maxk = j;
<a name="line156">156: </a>      }
<a name="line157">157: </a>    }
<a name="line158">158: </a>    exchange(Stk+j-1,Stk+maxk);
<a name="line159">159: </a>    exchange(St0+j-1,St0+maxk);
<a name="line160">160: </a>    exchange(vol+j-1,vol+maxk);
<a name="line161">161: </a>  }
<a name="line162">162: </a>
<a name="line163">163: </a>  payoff = 0;
<a name="line164">164: </a>  <font color="#4169E1">for</font> (i=0;i&lt;n;i++){
<a name="line165">165: </a>    temp = (Stk[i]/St0[i]) - 1 ;
<a name="line166">166: </a>    <font color="#4169E1">if</font> (temp &gt; 0) payoff += temp;
<a name="line167">167: </a>  }
<a name="line168">168: </a>  <font color="#4169E1">return</font> payoff;
<a name="line169">169: </a>}

<a name="line173">173: </a><strong><font color="#4169E1"><a name="readData"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> readData(<A href="../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,himaInfo *hinfo)</font></strong>
<a name="line174">174: </a>{
<a name="line175">175: </a>  int            i;
<a name="line176">176: </a>  FILE           *fd;
<a name="line177">177: </a>  char           temp[50];
<a name="line179">179: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line180">180: </a>  double         *v = hinfo-&gt;vol, *t = hinfo-&gt;St0;
<a name="line181">181: </a>  int            num=hinfo-&gt;n;
<a name="line182">182: </a>
<a name="line184">184: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line185">185: </a>  <font color="#4169E1">if</font> (!<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>){
<a name="line186">186: </a>    <A href="../../../../docs/manualpages/Sys/PetscFOpen.html#PetscFOpen">PetscFOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,DATAFILENAME,<font color="#666666">"r"</font>,&amp;fd);
<a name="line187">187: </a>    <font color="#4169E1">for</font> (i=0;i&lt;num;i++){
<a name="line188">188: </a>      fscanf(fd,<font color="#666666">"%s%lf%lf"</font>,temp,v+i,t+i);
<a name="line189">189: </a>    }
<a name="line190">190: </a>    fclose(fd);
<a name="line191">191: </a>  }
<a name="line192">192: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Bcast.html#MPI_Bcast">MPI_Bcast</A>(v,2*num,MPI_DOUBLE,0,<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>);
<a name="line193">193: </a>  //<A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"[%d] vol %g, ... %g; St0 %g, ... %g\n"</font>,<A href="../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,hinfo-&gt;vol[0],hinfo-&gt;vol[num-1],hinfo-&gt;St0 [0],hinfo-&gt;St0[num-1]);
<a name="line194">194: </a>  <font color="#4169E1">return</font>(0);
<a name="line195">195: </a>}

<a name="line197">197: </a><strong><font color="#4169E1"><a name="exchange"></a>void exchange(double *a, double *b)</font></strong>
<a name="line198">198: </a>{
<a name="line199">199: </a>  double t;
<a name="line200">200: </a>
<a name="line201">201: </a>  t = *a;
<a name="line202">202: </a>  *a = *b;
<a name="line203">203: </a>  *b = t;
<a name="line204">204: </a>}

<a name="line206">206: </a><strong><font color="#4169E1"><a name="mcVal"></a>double mcVal(double St, double r, double vol, double dt, double eps)</font></strong>
<a name="line207">207: </a>{
<a name="line208">208: </a>  <font color="#4169E1">return</font> (St * exp((r-0.5*vol*vol)*dt + vol*sqrt(dt)*eps));
<a name="line209">209: </a>}

<a name="line211">211: </a><strong><font color="#4169E1"><a name="divWork"></a>unsigned long divWork(int id, unsigned long num, int np)</font></strong>
<a name="line212">212: </a>{
<a name="line213">213: </a>  unsigned long numit;

<a name="line215">215: </a>  numit = (unsigned long)(((double)num)/np);
<a name="line216">216: </a>  numit++;
<a name="line217">217: </a>  <font color="#4169E1">return</font> numit;
<a name="line218">218: </a>}


</pre>
</body>

</html>
